class MultiLoader
{
    // list of items and urls
    var allItems:Array;
    // callback object
    var displayable:Object;
    // are we loading?
    var loading:Boolean;
    // have we loaded
    var loaded:Boolean;
    // number of items loaded
    var itemsLoaded:Number;
    
    //# aImages is an array of objects to load.  you can also use enqueue.
    function MultiLoader( aImages:Array )
    {
        allItems = aImages ? aImages : new Array();
        itemsLoaded = 0;
        loading = false;
        loaded = false;
    }
    //# start loading items in queue
    function startLoad( callback:Object )
    {
        var ref = this;
        var itemsToLoad = allItems.length;
        displayable = callback;
        loading = true;
        loaded = false;
        while( --itemsToLoad >= 0 )
        {
            var mcl = new MovieClipLoader();
            var lis = new Object();
            lis.onLoadInit = function ( target )
            {
                ref.onItemLoaded( target );
                ref.forceSmoothing = true;
            };
            lis.onLoadError = function ( target, errorCode )
            {
                ref.onItemFailed( target, errorCode );
            };
            lis.onLoadProgress = function ( target, bytesLoaded, bytesTotal )
            {
                ref.onItemProgress( target, bytesLoaded, bytesTotal );
            };
            mcl.addListener( lis );
            mcl.loadClip( allItems[itemsToLoad].url, allItems[itemsToLoad].targetClip );
        }
    }
    //# Add items to the loader
    function enqueue( url:String, target:MovieClip )
    {
        allItems.push( {url: url, targetClip: target} );
    }
    //# get an item to load ( internal )
    private function dequeue( Void )
    {
        return ( allItems.shift() );
    }
    //# event when an item has loaded
    function onItemLoaded( item )
    {
        displayable.onItem.apply( displayable.scope, [item] );
        if ( ++itemsLoaded == allItems.length )
        {
            this.onItemsLoaded();
        }
    }
    //# event when all items are loaded
    function onItemsLoaded( Void )
    {
        loaded = true;
        loading = false;
        displayable.onSuccess.apply( displayable.scope, [allItems] );
    }
    //# event when ite,s have failed
    function onItemFailed( item, error )
    {
        displayable.onFailed.apply( displayable.scope, [item, error] );
    }
    //# event when item is loading
    function onItemProgress( item, bytesLoaded, bytesTotal )
    {
        displayable.onProgress.apply( displayable.scope, [item, bytesLoaded, bytesTotal] );
    }
}

/*
function onImageItemLoaded( item )
{
    trace( "item '" + item + "' is loaded" );
}
//# when an item is loading
function onImageProgress( item, bytesLoaded, bytesTotal )
{
    trace( "image " + item + " : " + bytesLoaded + "/" + bytesTotal );
}
//# when all items have loaded
function onImagesLoaded( images )
{
    trace( "Images have loaded:");
    for ( var i in images )
    {
        trace( "\turl: " + images[i].url + " has loaded" );
    }
}
//# when an item has failed
function onImagesFailed( item, error )
{
    trace( "item " + item + " has failed: " + error );
}
//# instantiate a new MultiLoader
var myLoader = new MultiLoader();
//# add items to the list
myLoader.enqueue( "Image50x80_1.jpg", _root.movie1 );
myLoader.enqueue( "Image50x80_2.jpg", _root.movie2 );
myLoader.enqueue( "Image50x80_3.jpg", _root.movie3 );
//# start the loading with yoru callback objects
myLoader.startLoad({
    // path to the functions
    scope: this, 
    // when all items have loaded
    onSuccess: onImagesLoaded, 
    // when an item has failed
    onFailed: onImagesFailed, 
    // on item loading
    onProgress: onImageProgress, 
    // on item loaded
    onItem: onImageItemLoaded
});

*/